#!/usr/bin/env python

import cookielib
import os
import random
import time
import urllib, urllib2

# Whether or not to throttle connection attempts
# If so, the script waits between 5-10 seconds between each upload attempt
# If not, the script tries to upload continuously
THROTTLE = True

# Whether we're using Tor
TOR = False

# First parameter is the return e-mail used in the form
# Second parameter is the text file to upload
uploads = {"alice@wonderland.info": "Alice.txt",
           "marx@communism.org" : "Capital.txt",
           "marx_engels@communism.org": "CommunistManifesto.txt",
           "marquis@desade.sex": "DeSade.txt"}

# To add more referers, simply add another string to the list
referers = ['http://let.the.air.force.have.a.bake.sale.to.raise.money.gov', 'http://learn.about.research.before.you.cut.what.you.dont.know.gov', 'http://some.things.arent.put.to.a.vote.such.as.human.rights.gov', 'http://why.dont.we.cut.money.for.killing.such.as.the.defense.department.gov']

COOKIEFILE = "cookies.lwp"

youCutURL = "http://www.mattlira.com/Whip/YCprocessCA.asp"


cj = cookielib.LWPCookieJar()

def sendYouCutSuggestion(emailw, awardw, awardc, referer):

    params = {'emailw': emailw,
              'awardw': awardw,
              'awardc': awardc}

    headers = {'User-Agent': 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0. 6) Gecko/2009020911 Ubuntu/8.04 (hardy) Firefox/3.0.6',
    'Referer': referer,
    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8'}

    paramsEncoded = urllib.urlencode(params)

    if os.path.isfile(COOKIEFILE):
        cj.load(COOKIEFILE)

    if TOR:
        proxy_support = urllib2.ProxyHandler({"http" : "127.0.0.1:8118"})
        opener = urllib2.build_opener(proxy_support)
    else:
        opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))

    request = urllib2.Request(youCutURL, paramsEncoded, headers)

    try:
        handle = opener.open(request)
    except urllib2.HTTPError, e:
        print "unable to open request: %s" % e

    result = handle.read()
    #print result
    opener.close()

    print "Upload succeeded"

if __name__ == "__main__":

    while 1:
        awardNumber = random.randrange(0, 2000000000)
        email = random.choice(uploads.keys())
        textFile = uploads[email]
    
        fp = open(textFile, 'r')
        text = fp.readlines()
        fp.close()
    
        referer = random.choice(referers)
    
        print "Trying to submit from %s, with awardNumber %s and referer %s" % (email, awardNumber, referer)
    
        sendYouCutSuggestion(email, awardNumber, text, referer)

        if THROTTLE:
            sleepTime = random.randrange(5, 10)
            print "Sleeping for %d" % sleepTime
            time.sleep(sleepTime)
